/**
 * Follow me home.
 *
 * Version: 1.0
 * Date: 2011-07-03
 * (c) Geert Van Espen (geert@vanespen.com)
 */

//#define DWENGO
#ifdef __18F4550
#define DWENGO
#endif

#ifdef DWENGO

#include <dwengoConfig.h>
#include <dwengoBoard.h>

#else

#include "Follow.h"
//#include "FollowBoard.h"

#define TRUE    1
#define FALSE   0
#define HIGH    1
#define LOW     0
#define PRESSED 0
#define INPUT   1
#define OUTPUT  0

void delay_ms(int);
void setCursorLCD(unsigned char a, unsigned char b) {}
void appendIntToLCD(int a) {}
void appendStringToLCD_(const far rom char* message) {}
void appendStringToLCD_(const far rom char*);
#define appendStringToLCD(message)   appendStringToLCD_((const far rom char*)(message))
void initBoard(void) {}
void backlightOn(void) {}
void backlightOff(void) {}
void clearLCD(void) {}


#ifdef __18F2550
#include <p18f2550.h>
#endif

#ifdef __18F4550
#include <p18f4550.h>
#endif

#endif

#include <timers.h>
#include <pwm.h>
#include <delays.h>


/*unsigned int g[64] = {
  0, 3, 7, 7, 7, 11, 11, 11, 11, 11, 11, 15, 15, 15, 15, 19, 
  19, 19, 23, 23, 27, 27, 31, 35, 35, 39, 43, 47, 51, 55, 59, 63, 
  71, 75, 83, 91, 99, 107, 115, 127, 139, 151, 163, 179, 195, 211, 231, 251, 
  275, 299, 327, 359, 391, 427, 467, 507, 555, 603, 659, 719, 787, 859, 939, 1023
};*/
unsigned int g[64] = {
  0, 2, 3, 5, 7, 8, 9, 10, 11, 11, 11, 12, 13, 14, 15, 16, 
  17, 19, 23, 23, 27, 27, 31, 35, 35, 39, 43, 47, 51, 55, 59, 63, 
  71, 75, 83, 91, 99, 107, 115, 127, 139, 151, 163, 179, 195, 211, 231, 251, 
  275, 299, 327, 359, 391, 427, 467, 507, 555, 603, 659, 719, 787, 859, 939, 1023
};

#define INTERVAL_SECS 30
#define MAX 63
#define MAX_DELAYMODE 8
#define MAX_PRESSED 200

// Prototypes.
void showDelayMode(int delayMode);


void main(void)
{
  unsigned int p = 0, pt = 0;
  int test = 0, firstTime = 1;
  unsigned long msDelayed = 0;
  unsigned long msToDelay = 0;
  unsigned long delayedPercentage = 0;
  int buttonOnTime = 0;
  int delayMode = 0;

  // Initialise the board.
  initBoard();

  // Set internal oscillator to 8 MHz.
  OSCCONbits.IRCF0 = 1;
  OSCCONbits.IRCF1 = 1;
  OSCCONbits.IRCF2 = 1;


  // Show startup info on LCD.
  backlightOn();
  appendStringToLCD("Follow me home");
  
  // Set inputs/outputs.
  TRISAbits.TRISA4 = 0;
  TRISAbits.TRISA5 = 0;

#ifdef DWENGO
  TRISDbits.TRISD0 = 0;
  TRISDbits.TRISD1 = 0;
  TRISDbits.TRISD2 = 0;
  TRISDbits.TRISD3 = 0;
  TRISDbits.TRISD4 = 0;
  TRISDbits.TRISD5 = 0;
  TRISDbits.TRISD6 = 0;
  TRISDbits.TRISD7 = 0;

  // All LEDs of Dwengo board off.
  PORTD = 0;
#endif

  // Enable pull-ups on PORTB.
  INTCON2bits.NOT_RBPU = 0;

  // Initialise PWM module.
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 0;
  PORTAbits.RA4 = 1;       // Activate HOLD-relay.
  
  PORTCbits.RC1 = 0;
  PORTAbits.RA5 = 1;       // Activate Headlight.

  OpenPWM2(0xFF);
  OpenTimer2(TIMER_INT_OFF & T2_PS_1_16 & T2_POST_1_1);

  // Set duty cycle of PWM to 0 percent.
  SetDCPWM2(0);

  delayMode = 1;
  msToDelay = INTERVAL_SECS * 1000L;
  showDelayMode(delayMode);

  // Wait a short while.
  //delay_ms(12);


  while (TRUE)
  {
    delay_ms(12);
    msDelayed += 14L;
    delayedPercentage = msDelayed / (msToDelay / 100L);
    test = ((msToDelay - msDelayed) / (INTERVAL_SECS * 1000L)) +1L;
    delayMode = test;
    showDelayMode(delayMode);
    setCursorLCD(1, 4);
    appendIntToLCD(delayedPercentage);
    appendStringToLCD("  ");
    //setCursorLCD(1, 8);
    //appendIntToLCD(test);
    //appendStringToLCD("  ");

    if (msDelayed >= msToDelay)
    {
      while (TRUE)
      {
        PORTAbits.RA5 = 0;          // Headlight off.
        PORTAbits.RA4 = 0;          // HOLD-relay off.
        SetDCPWM2(0);
        backlightOff();
        clearLCD();
        _asm
        sleep
        _endasm
      }
    }

    PORTAbits.RA5 = 1;          // Headlight on.
    if (PORTBbits.RB0 == 0)     // Count ON-time of button.
      buttonOnTime++;

    if (buttonOnTime > MAX_PRESSED)     // Button pressed more than 2 secs.
    {
      while (TRUE)
      {
        PORTAbits.RA5 = 0;          // Headlight off.
        PORTAbits.RA4 = 0;          // HOLD-relay off.
        SetDCPWM2(0);
        backlightOff();
        clearLCD();
        _asm
        sleep
        _endasm
      }
    }

    if (PORTBbits.RB0 == 1)     // Button released.
    {
      if (buttonOnTime)
      {
        buttonOnTime = 0;
        if (firstTime)
        {
          firstTime = 0;
        }
        else
        {
          delayMode++;
          if (delayMode > MAX_DELAYMODE) delayMode = MAX_DELAYMODE;
          msToDelay = (long)delayMode * INTERVAL_SECS * 1000L;
          msDelayed = 0;
          showDelayMode(delayMode);
        }
      }
    }
  }
}

void showDelayMode(int delayMode)
{
  unsigned int p = 0, pt = 0;

  setCursorLCD(1, 0);
  appendIntToLCD(delayMode);
  appendStringToLCD("  ");

  p = (delayMode * 100) / MAX_DELAYMODE;
  p *= 64;
  p /= 100;
  p--;
  pt = g[p];
  SetDCPWM2(pt);
}


#ifndef DWENGO
void delay_ms(int d)
{
  int i;
  for (i = 0; i < 20; i++) Delay100TCYx(d);
}


#endif

